captureEventActive = false;
CaptureWindowLive = false;
local CapturePodAvailable = false;
-- local WindowState = WowkemonCaptureFrame:isShown()
local activeWowkemonID = nil;
WowkemonCubeButtonLock = false;
local CandyMultiplier = 100;
local WowkemonLevel = 0
local currentlyThrowing = false;
local activeLevel = 0;

function BeginCaptureEvent(WowkemonID,uniqueLoc)
  PlayMusic(WDir.."\\resources\\sound\\music_arcade.mp3")
  local zone =   GetRealZoneText();
  local subZone = GetSubZoneText()
  local level = selectWildWowkemonSpawnLevel()
  activeLevel = level;
  if uniqueLoc == false then
    activeWowkemonID = WowkemonID
  else
    activeWowkemonID = wowkemonUniqueSpawnLocs[subZone][WowkemonID];
 end
 -- Set the Zone backdrop to our current zone, or default to placeholder if not found.
 if ZoneTextures[zone] ~= nil then
  WowkemonCaptureFrame.Background:SetTexture(ZoneTextures[zone]);
  else
    WowkemonCaptureFrame.Background:SetTexture(ZoneTextures["Loch Modan"]);
end
-- Set the wowkemon model to the wowkemon we've encountered
WowkemonCaptureFrame.Wowkemon:SetTexture(nil) --(activeWowkemonID[2])
WowkemonCaptureFrame.Wowkemon3d:SetDisplayInfo(activeWowkemonID[6] or 728)
WowkemonCaptureFrame.Wowkemon3d:SetCreature(activeWowkemonID[6] or 728)
WowkemonCaptureFrame.Wowkemon3d:SetPosition(activeWowkemonID[7] or {0,0,0})
--WowkemonCaptureFrame.Wowkemon3d:SetModel("wowkemon\\spheretest.mdx")
WowkemonCaptureFrame.WowkemonDetailText:SetText("Level "..level.." "..activeWowkemonID[1])
indexOfTargetToCapture = level
end


function CubeClicked(time)
  if WowkemonPlayerData["Capture Cube"] > 0 then
    if currentlyThrowing == false  then
          PlaySoundFile(WDir.."\\resources\\sound\\effect_toss.mp3")
        currentlyThrowing = true;
          clearFeedbackText()
    WowkemonPlayerData["Capture Cube"] = (WowkemonPlayerData["Capture Cube"] - 1)
    if WowkemonCubeButtonLock == false then
        WowkemonCubeButtonLock = true;
          local InitialChance = (1 - time) * 100;
  WowkemonThrowAnimation(time,InitialChance);

  setFeedbackText(InitialChance);
end
end
else
  WowkemonCaptureFrame.CaptureTextHitResult:SetText("You don't have any Capture Cubes!");
end
end

function CubeThrowAnimFinished(time,InitialChance)
  if WowkemonPlayerData["Capture Cube"] >= 0  then

    clearFeedbackText()
    --  local InitialChance = (1 - time) * 100;
    --  setFeedbackText(InitialChance);
    --  Wowkemon__wait(2.5,clearFeedbackText);
      if math.random(100) < InitialChance then
        PlaySoundFile(WDir.."\\resources\\sound\\cubeHit.mp3")
        WowkemonCaptureFrame.CaptureTextHitResult:SetText("Hit!");
      --  WowkemonCaptureFrame.Wowkemon:SetTexture(WDir.."\\resources\\textures\\misc\\wowkeCubeShut.tga")
        WowkemonCaptureFrame.Wowkemon3d:SetDisplayInfo(14386)
        Wowkemon3dFrame:SetSize(Wowkemon3dFrame:GetWidth()*2,Wowkemon3dFrame:GetHeight()*2)
        WowkemonCaptureFrame.Wowkemon3d:SetCreature(14386)
        WowkemonCaptureFrame.Wowkemon3d:SetAnimation(2)

        DecideIfCaptured(InitialChance);
        WowkemonCaptureFrame.Wowkemon:SetScale(0.25)
        WowkemonCaptureFrame.abortButton:Hide();
        else
          WowkemonCaptureFrame.CaptureTextHitResult:SetText("Miss!");
          unlockCubeClick()
            PlaySoundFile(WDir.."\\resources\\sound\\cubeMiss.mp3")
          currentlyThrowing = false
      end

    end
end

function DecideIfCaptured(score)
  local playerLevel = WowkemonPlayerLevel
print(activeLevel)
  if indexOfTargetToCapture ~= 0 then
     WowkemonLevel = indexOfTargetToCapture
else
  WowkemonLevel = 14;
end
local PlayerLevel = WowkemonPlayerData["level"];
local finalChance = score
if
  PlayerLevel <= activeLevel then
    if activeLevel - PlayerLevel < 5 then
      finalChance  =  math.max(score - ((activeLevel / PlayerLevel)),10)
    --  print(finalChance.."%")
  --    print("Final Capture chance = ".. score .." - "..((WowkemonLevel / PlayerLevel) * 10 / 3).. " = " .. finalChance .. "Wowkemon level: "..WowkemonLevel)
    elseif activeLevel - PlayerLevel < 10 then
        finalChance  =  math.max(score - ((activeLevel / PlayerLevel) * 10 /2 ),5)
  --      print("Final Capture chance = ".. score .." - "..((WowkemonLevel / PlayerLevel) * 10 / 2).. " = " .. finalChance .. "Wowkemon level: "..WowkemonLevel)
elseif activeLevel - PlayerLevel > 0 then
      print("over 10 levels different(you are low)"..activeLevel - PlayerLevel)
        finalChance  =  math.min(score - ((activeLevel / PlayerLevel) * 20),1)
  --      print("Final Capture chance = ".. score .." - "..((WowkemonLevel / PlayerLevel) * 10).. " = " .. finalChance .. "Wowkemon level: "..WowkemonLevel)
    end
else
  if PlayerLevel - activeLevel > 10 then
    finalChance  =  math.max(score + ((activeLevel / PlayerLevel)),95)
  --  print(finalChance.."%")
--    print("Final Capture chance = ".. score .." - "..((WowkemonLevel /sss PlayerLevel) * 10 / 3).. " = " .. finalChance .. "Wowkemon level: "..WowkemonLevel)
elseif playerLevel - activeLevel > 5 then
      finalChance  =  math.max(score + ((activeLevel / PlayerLevel) * 10),60)
--      print("Final Capture chance = ".. score .." - "..((WowkemonLevel / PlayerLevel) * 10 / 2).. " = " .. finalChance .. "Wowkemon level: "..WowkemonLevel)
  else
      finalChance  =  math.max(score + (playerLevel - activeLevel)*10,20)
--      print("Final Capture chance = ".. score .." - "..((WowkemonLevel / PlayerLevel) * 10).. " = " .. finalChance .. "Wowkemon level: "..WowkemonLevel)
  end
end

WowkemonCaptureFrame.CaptureTextClickResult:SetText(round(finalChance,0).."%")
Wowkemon__wait(1,setFeedbackStatusText,"3");
Wowkemon__wait(2,setFeedbackStatusText,"2");
Wowkemon__wait(3,setFeedbackStatusText,"1");
Wowkemon__wait(4,setFeedbackStatusText,"");
Wowkemon__wait(4,ActionCaptureDecision,finalChance,activeLevel);
end

function ActionCaptureDecision(chance,activeLevel)
  StopMusic();
  if WowkemonActiveBuffs["Akureit"] ~= nil then
    chance = chance+WowkemonItemData["Akureit"][1];
    print("Boost active. Total chance "..chance.."%")
  end
if math.random(100) < chance then
  -- captured!
  WowkemonCaptureFrame.CaptureTextClickResult:SetText("Caught!!")
    WowkemonCaptureFrame.CaptureTextHitResult:SetText("Nice!");
    WowkemonCaptureFrame.Wowkemon3d:SetAnimation(0)
    Wowkemon3dFrame:SetSize(Wowkemon3dFrame:GetWidth()/2,Wowkemon3dFrame:GetHeight()/2)
        PlaySoundFile(WDir.."\\resources\\sound\\jingle_achieve.mp3")
        wowkemonAwardXP(activeLevel)
    Wowkemon__wait(2,updateWowkedex,activeWowkemonID,activeLevel)
    WowkemonCaughtEvent()
    checkCapQuestStatus()
else
  -- broke free!
    WowkemonCaptureFrame.CaptureTextClickResult:SetText("Wowkemon got away.")
      WowkemonCaptureFrame.CaptureTextHitResult:SetText("Unlucky!");
      WowkemonCaptureFrame.Wowkemon3d:SetAnimation(5)
      WowkemonCaptureFrame.Wowkemon3d:ClearModel()
      Wowkemon3dFrame:SetSize(Wowkemon3dFrame:GetWidth()/2,Wowkemon3dFrame:GetHeight()/2)
    PlaySoundFile(WDir.."\\resources\\sound\\jingle_lose.mp3")

    WowkemonCaptureFrame.Wowkemon:SetTexture(WDir.."\\resources\\textures\\misc\\wowkeCubeBroken.tga")
    WowkemonCaptureFrame.closeButton:Show()

end

end

function checkCapQuestStatus()
  for e in pairs(WowkemonPlayerData["quests"]) do
    if WowkemonPlayerData["quests"][e][1] == "capture" and WowkemonPlayerData["quests"][e][2] == GetZoneText() then
      table.remove(WowkemonPlayerData["quests"],e);
      print("|cffFFff00 Wowkemon Quest Complete!|r")
      WowkemonAddItem("Capture Cube",math.random(10));
    end
  end
end
-- Update the display text to reflect the shot accuracy
function setFeedbackText(result)
  if result > 90 then
WowkemonCaptureFrame.CaptureTextClickResult:SetText("Excellent!\nAccuracy: "..round(result,2).."%")
elseif result > 80 then
  WowkemonCaptureFrame.CaptureTextClickResult:SetText("Great!\nAccuracy: "..round(result,2).."%")
elseif result > 70 then
  WowkemonCaptureFrame.CaptureTextClickResult:SetText("OK!\nAccuracy: "..round(result,2).."%")
elseif result > 50 then
  WowkemonCaptureFrame.CaptureTextClickResult:SetText("Weak!\nAccuracy: "..round(result,2).."%")
elseif result > 30 then
  WowkemonCaptureFrame.CaptureTextClickResult:SetText("Bad!\nAccuracy: "..round(result,2).."%")
else
  WowkemonCaptureFrame.CaptureTextClickResult:SetText("Terrible!\nAccuracy: "..round(result,2).."%")
end
end

function setFeedbackStatusText(text)
    WowkemonCaptureFrame.CaptureTextHitResult:SetText(text);
end

function clearFeedbackText()
  WowkemonCaptureFrame.CaptureTextClickResult:SetText("")
  WowkemonCaptureFrame.CaptureTextHitResult:SetText("");
end

function unlockCubeClick()
WowkemonCubeButtonLock = false;
  currentlyThrowing =false;
end


function updateWowkedex(Wowkemon,level)
if  WowkemonPlayerData["Wowkedex"][Wowkemon[1]] == nil then
    WowkemonPlayerData["Wowkedex"][Wowkemon[1]] = {level*CandyMultiplier,1,level,{},["Stats"] = {["Stamina"] = 5} }
    for e in pairs(activeWowkemonID[4]) do
      WowkemonPlayerData["Wowkedex"][Wowkemon[1]][4][activeWowkemonID[4][e]] = 1;
    end
    print("|cffFFff00 You caught a new Wowkemon! \n"..Wowkemon[1].." added to Wowkedex! |r")
    addToWowkedexList(Wowkemon)

  else
    WowkemonPlayerData["Wowkedex"][Wowkemon[1]][1] = WowkemonPlayerData["Wowkedex"][Wowkemon[1]][1] + (level * CandyMultiplier);
    WowkemonPlayerData["Wowkedex"][Wowkemon[1]][2] = WowkemonPlayerData["Wowkedex"][Wowkemon[1]][2] + 1;
    WowkemonPlayerData["Wowkedex"][Wowkemon[1]][3] = math.max(WowkemonPlayerData["Wowkedex"][Wowkemon[1]][3],level);
end

WowkemonCaptureFrame.CaptureTextClickResult:SetText("XP:"..(level*100).." \n".."Candy: "..level * CandyMultiplier)
WowkemonCaptureFrame.closeButton:Show()

end

function WowkemonThrowAnimation(time,InitialChance)
  local AnimGroup = WowkemonCaptureFrame.CaptureItem:CreateAnimationGroup("CubeAnimationGrp",WowkemonCaptureFrame)
  local Anim = AnimGroup:CreateAnimation("Translation")

   Anim:SetOffset(-115,115)
   Anim:SetDuration(1)
  --  AnimGroup:Play()

  Wowkemon__wait(1,CubeThrowAnimFinished,time,InitialChance)

  local loops = 30
  local curLoop = 0
  --for i=1,loops,1 do
  --print("loop.."..i)
  --if i~=loops then
  WowkemonCaptureFrame.CaptureItem.Model:SetSize(WowkemonCaptureFrame.CaptureItem.Model:GetWidth()*2,WowkemonCaptureFrame.CaptureItem.Model:GetHeight()*2)
  WowkemonCaptureFrame.CaptureItem.Model:SetAllPoints()
  for i = 1,loops do
    curLoop = curLoop + 1
    if curLoop ~= loops then
Wowkemon__wait(0.033*curLoop,wowkemonUpdateCubeModelPos,-8*curLoop,8*curLoop)
else
  Wowkemon__wait(0.033*curLoop,wowkemonUpdateCubeModelPos,0,0 )
  end
end
  local no = false
  if no == true then
    Wowkemon__wait(0.1,wowkemonUpdateCubeModelPos,-20,20)
  Wowkemon__wait(0.2,wowkemonUpdateCubeModelPos,-40,40)
    Wowkemon__wait(0.3,wowkemonUpdateCubeModelPos,-60,60)
    Wowkemon__wait(0.4,wowkemonUpdateCubeModelPos,-80,80)
      Wowkemon__wait(0.5,wowkemonUpdateCubeModelPos,-100,100)
    Wowkemon__wait(0.6,wowkemonUpdateCubeModelPos,-120,120)
      Wowkemon__wait(0.7,wowkemonUpdateCubeModelPos,-140,140)
        Wowkemon__wait(0.8,wowkemonUpdateCubeModelPos,-160,160)
          Wowkemon__wait(0.9,wowkemonUpdateCubeModelPos,-180,180)
      --      Wowkemon__wait(1,wowkemonUpdateCubeModelPos,-0,200)
      Wowkemon__wait(1,wowkemonUpdateCubeModelPos,0,0)
    end
        Wowkemon__wait(1, function()
        WowkemonCaptureFrame.CaptureItem.Model:SetSize(WowkemonCaptureFrame.CaptureItem.Model:GetWidth()/2,WowkemonCaptureFrame.CaptureItem.Model:GetHeight()/2)end)
--else
--    wowkemonUpdateCubeModelPos(0,0)
--  end
--end
end


function wowkemonUpdateCubeModelPos(x,y)
  WowkemonCaptureFrame.CaptureItem.Model:SetPoint("TOPLEFT",x,y)
end
