-- Trainer level management and info


wowkemonTrainerLevelXPRequirements = {
  {1000},
  {3000},
  {5000},
  {8000},
  {10000},
  {20000},
  {30000},
  {40000},
  {60000},
  {70000},
  {80000},
  {90000},
  {100000},
  {100000},
  {110000}, -- 15
  {130000},
  {150000},
  {170000},
  {180000},
  {200000}, -- 20
  {220000},
  {240000},
  {260000},
  {280000},
  {300000}, -- 25
  {300000},
  {300000},
  {300000},
  {300000},
  {0} -- 30 (CAP)
  }


function wowkemonAwardXP(activeLevel)
  local xp = activeLevel - WowkemonPlayerLevel
  if WowkemonPlayerData["level"] ~= 30 then
    if WowkemonPlayerData["XP"] + (100 * activeLevel) > wowkemonTrainerLevelXPRequirements[WowkemonPlayerData["level"]][1] then
      WowkemonPlayerData["level"] = WowkemonPlayerData["level"] + 1;
      print("|cffFFff00Wowkemon: trainer level up!|r")
      if WowkemonPlayerData["XP"] + (100 * activeLevel) - wowkemonTrainerLevelXPRequirements[WowkemonPlayerData["level"]][1] > 0 then
        WowkemonPlayerData["XP"] = WowkemonPlayerData["XP"] + (100 * activeLevel) - wowkemonTrainerLevelXPRequirements[WowkemonPlayerData["level"]][1];
        wowkemonAwardXP(0)
      end
    else
      WowkemonPlayerData["XP"] = WowkemonPlayerData["XP"] + (100 * activeLevel);
    end
  end
end


function AnalyseXPState()
--  print("checkingxp")
  if WowkemonPlayerData["XP"] - wowkemonTrainerLevelXPRequirements[WowkemonPlayerData["level"]][1] > 0 then
    wowkemonAwardXP(0);
  end
end
