-- PVP Battle frames and content

local chosenWowkemonID = selectedPVPWowkemon;
local chosenWowkemonLevel = 1;
local chosenWowkemonHP = 100;
local wowkemonPvpFrame = nil;
local wowkemonlobbyFrame = nil;
local playerWowkemonTexturePath = nil;
local SkillButtons = {};

function wowkemonLoadLobby()
if wowkemonlobbyFrame == nil then
  wowkemonlobbyFrame = CreateFrame("Frame","wowkemonLobbyFrame",UIParent)
  wowkemonlobbyFrame:SetSize(600,300)
  wowkemonlobbyFrame:SetPoint("CENTER")
  wowkemonlobbyFrame:SetBackdrop(CaptureFrameBackdrop)

  wowkemonlobbyFrame.chosenWowkemon = wowkemonlobbyFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
  wowkemonlobbyFrame.chosenWowkemon:SetText("Selected Wowkemon:\n"..selectedPVPWowkemon);
  wowkemonlobbyFrame.chosenWowkemon:SetPoint("TOP",wowkemonLobbyFrame,"TOP",0,-20)
  wowkemonlobbyFrame.chosenWowkemonAvatar = wowkemonlobbyFrame:CreateTexture(nil,"OVERLAY");

  for e in pairs(Wowkemons) do
    if Wowkemons[e][1] == selectedPVPWowkemon then
      wowkemonlobbyFrame.chosenWowkemonAvatar:SetTexture(Wowkemons[e][2]);
      playerWowkemonTexturePath = Wowkemons[e][2];
    end
  end
  wowkemonlobbyFrame.chosenWowkemonAvatar:SetPoint("TOP",wowkemonlobbyFrame.chosenWowkemon,"BOTTOM")


  wowkemonlobbyFrame.readyButton = CreateFrame("Button","wowkemonFightReadyButton",wowkemonlobbyFrame,"UIPanelButtonTemplate")
  wowkemonlobbyFrame.readyButton:SetSize(150,50);
  wowkemonlobbyFrame.readyButton:SetText("Ready!");
  wowkemonlobbyFrame.readyButton:SetPoint("CENTER")
  wowkemonlobbyFrame.readyButton:SetScript("OnClick",function() wowkemonBattleSendReadySignal(selectedPVPWowkemon,chosenWowkemonLevel,chosenWowkemonHP) end);

  wowkemonlobbyFrame.closeButton = CreateFrame("Button","wowkemonpvpframeclosebtn",wowkemonlobbyFrame,"UIPanelButtonTemplate")
  wowkemonlobbyFrame.closeButton:SetSize(20,20)
  wowkemonlobbyFrame.closeButton:SetText("X");
  wowkemonlobbyFrame.closeButton:SetPoint("TOPRIGHT",wowkemonlobbyFrame,"TOPRIGHT");
  wowkemonlobbyFrame.closeButton:SetScript("OnClick",function () wowkemonBattleSendForfeitNotice() wowkemonlobbyFrame:Hide() end)
end

for e in pairs(Wowkemons) do
  if Wowkemons[e][1] == selectedPVPWowkemon then
    wowkemonlobbyFrame.chosenWowkemonAvatar:SetTexture(Wowkemons[e][2]);
    playerWowkemonTexturePath = Wowkemons[e][2];
  end
end

wowkemonLobbyFrame:Show();
end

function wowkemonLoadPvpFrame(opponentData)
if wowkemonPvpFrame == nil then -- Build the frame if it doesn't exist.


  wowkemonPvpFrame = CreateFrame("Frame","wowkemonpvpframe",UIParent);
  wowkemonPvpFrame:SetSize(600,300);
  wowkemonPvpFrame:SetPoint("CENTER")
  wowkemonPvpFrame:SetBackdrop(CaptureFrameBackdrop);

  wowkemonPvpFrame.closeButton = CreateFrame("Button","wowkemonpvpframeclosebtn",wowkemonPvpFrame,"UIPanelButtonTemplate")
  wowkemonPvpFrame.closeButton:SetSize(20,20)
  wowkemonPvpFrame.closeButton:SetText("X");
  wowkemonPvpFrame.closeButton:SetPoint("TOPRIGHT",wowkemonPvpFrame,"TOPRIGHT");
  wowkemonPvpFrame.closeButton:SetScript("OnClick",function () StopMusic() wowkemonBattleSendForfeitNotice() wowkemonPvpFrame:Hide() end)

  wowkemonPvpFrame.FeedbackString = wowkemonPvpFrame:CreateFontString(nil,"OVERLAY","GameFontNormal");
  wowkemonPvpFrame.FeedbackString:SetPoint("CENTER",wowkemonPvpFrame,"CENTER",0,20);

  wowkemonPvpFrame.player = wowkemonPvpFrame:CreateTexture(nil,"OVERLAY");
  wowkemonPvpFrame.player:SetSize(100,100)
  wowkemonPvpFrame.player:SetPoint("LEFT");
  wowkemonPvpFrame.playerHP = wowkemonPvpFrame:CreateFontString(nil,"OVERLAY","GameFontHighlight");
  wowkemonPvpFrame.playerHP:SetText("curHP/MaxHP");
  wowkemonPvpFrame.playerHP:SetPoint("TOPLEFT",wowkemonPvpFrame,"TOPLEFT",50,-25);
  wowkemonPvpFrame.playerAP = wowkemonPvpFrame:CreateFontString(nil,"OVERLAY","GameFontHighlight");
  wowkemonPvpFrame.playerAP:SetText("AP: 0");
  wowkemonPvpFrame.playerAP:SetPoint("TOPLEFT",wowkemonPvpFrame,"TOPLEFT",50,-50);

  wowkemonPvpFrame.PlayerOptionsCore = CreateFrame("Frame","wowkemonActionOptionsCore",wowkemonPvpFrame);
  wowkemonPvpFrame.PlayerOptionsCore:SetSize(100,100);
  wowkemonPvpFrame.PlayerOptionsCore:SetPoint("BOTTOMLEFT",wowkemonPvpFrame,"BOTTOMLEFT");
  wowkemonPvpFrame.PlayerOptionsCore:SetBackdrop(CaptureFrameBackdrop);
    wowkemonPvpFrame.PlayerOptionsCore.Attack = CreateFrame("Button","wowkemonAttackOptionsBtn",wowkemonPvpFrame.PlayerOptionsCore,"UIPanelButtonTemplate");
    wowkemonPvpFrame.PlayerOptionsCore.Attack:SetSize(100,25)
    wowkemonPvpFrame.PlayerOptionsCore.Attack:SetPoint("TOPLEFT",wowkemonPvpFrame.PlayerOptionsCore,"TOPLEFT",0,-5);
    wowkemonPvpFrame.PlayerOptionsCore.Attack:SetScript("OnClick",function ()  wowkemonHideActionFrames() wowkemonPvpFrame.playerOptionsT1:Show() wowkemonSetupTier1Action("Attack") end)
      wowkemonPvpFrame.PlayerOptionsCore.Attack.Text = wowkemonPvpFrame.PlayerOptionsCore.Attack:CreateFontString(nil,"OVERLAY","GameFontHighlight");
      wowkemonPvpFrame.PlayerOptionsCore.Attack.Text:SetPoint("CENTER",wowkemonPvpFrame.PlayerOptionsCore.Attack,"CENTER");
      wowkemonPvpFrame.PlayerOptionsCore.Attack.Text:SetText("Attack >");

      wowkemonPvpFrame.PlayerOptionsCore.Defense = CreateFrame("Button","wowkemonDefenseOptionsBtn",wowkemonPvpFrame.PlayerOptionsCore,"UIPanelButtonTemplate");
      wowkemonPvpFrame.PlayerOptionsCore.Defense:SetSize(100,25)
      wowkemonPvpFrame.PlayerOptionsCore.Defense:SetPoint("TOPLEFT",wowkemonPvpFrame.PlayerOptionsCore,"TOPLEFT",0,-25);
      wowkemonPvpFrame.PlayerOptionsCore.Defense:SetScript("OnClick",function ()  wowkemonHideActionFrames() wowkemonPvpFrame.playerOptionsT1:Show() wowkemonSetupTier1Action("Defense") end)
      wowkemonPvpFrame.PlayerOptionsCore.Defense.Text = wowkemonPvpFrame.PlayerOptionsCore.Defense:CreateFontString(nil,"OVERLAY","GameFontHighlight");
      wowkemonPvpFrame.PlayerOptionsCore.Defense.Text:SetPoint("CENTER",wowkemonPvpFrame.PlayerOptionsCore.Defense,"CENTER");
      wowkemonPvpFrame.PlayerOptionsCore.Defense.Text:SetText("Defense >");

      wowkemonPvpFrame.PlayerOptionsCore.Item = CreateFrame("Button","wowkemonItemOptionsBtn",wowkemonPvpFrame.PlayerOptionsCore,"UIPanelButtonTemplate");
      wowkemonPvpFrame.PlayerOptionsCore.Item:SetSize(100,25)
      wowkemonPvpFrame.PlayerOptionsCore.Item:SetPoint("TOPLEFT",wowkemonPvpFrame.PlayerOptionsCore,"TOPLEFT",0,-45);
      wowkemonPvpFrame.PlayerOptionsCore.Item:SetScript("OnClick",function () wowkemonHideActionFrames() wowkemonPvpFrame.playerOptionsT1:Show() wowkemonSetupTier1Action("Item") end)
      wowkemonPvpFrame.PlayerOptionsCore.Item.Text = wowkemonPvpFrame.PlayerOptionsCore.Item:CreateFontString(nil,"OVERLAY","GameFontHighlight");
      wowkemonPvpFrame.PlayerOptionsCore.Item.Text:SetPoint("CENTER",wowkemonPvpFrame.PlayerOptionsCore.Item,"CENTER");
      wowkemonPvpFrame.PlayerOptionsCore.Item.Text:SetText("Item >");

  wowkemonPvpFrame.playerOptionsT1 = CreateFrame("Frame","wowkemonActionOptionsAttack",wowkemonPvpFrame.PlayerOptionsCore);
  wowkemonPvpFrame.playerOptionsT1:SetSize(100,100);
  wowkemonPvpFrame.playerOptionsT1:SetPoint("LEFT",wowkemonPvpFrame.PlayerOptionsCore,"RIGHT");
  wowkemonPvpFrame.playerOptionsT1:SetBackdrop(CaptureFrameBackdrop)
  wowkemonPvpFrame.playerOptionsT1:Hide()

  wowkemonPvpFrame.playerOptionsT2 = CreateFrame("Frame","wowkemonActionOptionsDefense",wowkemonPvpFrame.PlayerOptionsCore);
  wowkemonPvpFrame.playerOptionsT2:SetSize(100,100)
  wowkemonPvpFrame.playerOptionsT2:SetPoint("LEFT",wowkemonPvpFrame.PlayerOptionsCore,"RIGHT",100,0);
  wowkemonPvpFrame.playerOptionsT2:SetBackdrop(CaptureFrameBackdrop)
  wowkemonPvpFrame.playerOptionsT2:Hide()

  wowkemonPvpFrame.playerOptionsT3 = CreateFrame("Frame","wowkemonActionOptionsItem",wowkemonPvpFrame.PlayerOptionsCore);
  wowkemonPvpFrame.playerOptionsT3:SetSize(100,100)
  wowkemonPvpFrame.playerOptionsT3:SetPoint("LEFT",wowkemonPvpFrame.PlayerOptionsCore,"RIGHT",200,0);
  wowkemonPvpFrame.playerOptionsT3:SetBackdrop(CaptureFrameBackdrop)
  wowkemonPvpFrame.playerOptionsT3:Hide();

  wowkemonPvpFrame.OpponentBorder = CreateFrame("Frame","wowkemonPvpFrameModelOpponentBorder",wowkemonPvpFrame)
  wowkemonPvpFrame.OpponentBorder:SetPoint("RIGHT")
  wowkemonPvpFrame.OpponentBorder:SetSize(100,100)
  wowkemonPvpFrame.Opponent = CreateFrame("DressUpModel", "wowkemonPvpFrameOpponentModel", wowkemonPvpFrame.OpponentBorder)
  wowkemonPvpFrame.Opponent:SetAllPoints()
  wowkemonPvpFrame.Opponent:SetPosition(0,0,0.5)
 wowkemonPvpFrame.Opponent:Show()
 wowkemonPvpFrame.OpponentBorder:Show()

  wowkemonPvpFrame.OpponentHP = wowkemonPvpFrame:CreateFontString(nil,"OVERLAY","GameFontHighlight");
  wowkemonPvpFrame.OpponentHP:SetText("curHP/MaxHP");
  wowkemonPvpFrame.OpponentHP:SetPoint("TOPRIGHT",wowkemonPvpFrame,"TOPRIGHT",-50,-25);
  end




  wowkemonLobbyFrame:Hide()
  wowkemonPvpFrame.player:SetTexture(playerWowkemonTexturePath)

  for e in pairs(Wowkemons) do
    if Wowkemons[e][1] == opponentData[2] then
        wowkemonPvpFrame.Opponent:SetTexture(Wowkemons[e][2]);
    end
  end
  wowkemonPvpFrame.OpponentHP:SetText(opponentData[4].."/"..opponentData[4]);


  wowkemonPvpFrame:Show();
  wowkemonPvpFrame.PlayerOptionsCore:Show()
  PlayMusic(WDir.."\\resources\\sound\\mountain_trials.mp3");
end


function wowkemonHideActionFrames()
wowkemonPvpFrame.playerOptionsT1:Hide()
wowkemonPvpFrame.playerOptionsT2:Hide()
wowkemonPvpFrame.playerOptionsT3:Hide()
end

function wowkemonHidePvpBattleFrames()
  if wowkemonlobbyFrame ~= nil then
    wowkemonlobbyFrame:Hide()
  end
  if wowkemonPvpFrame ~= nil then
    wowkemonPvpFrame:Hide()
  end
end

function wowkemonSetupTier1Action(type)
  local yOffset = 25;
  local step = 0;
  if type == "Attack" then
    for e in pairs(Wowkemons) do
      if Wowkemons[e][1] == selectedPVPWowkemon then
        for s in pairs(Wowkemons[e][4]) do
          if SkillButtons[s] == nil then
            local btn = CreateFrame("Button","wowkemonSkillButton"..s,wowkemonPvpFrame.playerOptionsT1,"UIPanelButtonTemplate");
            btn:SetSize(100,25);
  --      btn:SetPoint("CENTER",wowkemonPvpFrame.PlayerOptionsCore,"CENTER",yOffset*s,0)
            btn.textContent = btn:CreateFontString(nil,"OVERLAY","GameFontHighlight");
--        btn.textContent:SetPoint("CENTER",btn,"CENTER");
--        btn.textContent:SetText(WowkemonSkills[Wowkemons[e][4][s]]);
            table.insert(SkillButtons,btn);
          end
          SkillButtons[s]:SetPoint("TOPLEFT",wowkemonPvpFrame.playerOptionsT1,"TOPLEFT",0,-5-(yOffset*step));
          SkillButtons[s].textContent:SetPoint("CENTER",SkillButtons[s],"CENTER");
          SkillButtons[s].textContent:SetText(Wowkemons[e][4][s].."("..WowkemonSkills[Wowkemons[e][4][s]][4]..")");
          SkillButtons[s]:SetScript("OnClick",function () wowkemonBattleBuildBattleMessage(Wowkemons[e][4][s],WowkemonSkills[Wowkemons[e][4][s]][2]) end)
          step = step+1
        end
      end
    end
  else wowkemonHideActionFrames();
    print("Menu not yet implemented!");
  end

end

function wowkemonBattleToggleActionFrames(state)
  if state == "show" then
    wowkemonPvpFrame.PlayerOptionsCore:Show()
  else
    wowkemonPvpFrame.PlayerOptionsCore:Hide()
  end
end

function wowkemonUpdatePlayerHP(newHP)
  wowkemonPvpFrame.playerHP:SetText(newHP.."/"..currentWowkemonMaxHP);
end

function wowkemonUpdatePlayerAP(ap)
  wowkemonPvpFrame.playerAP:SetText("AP: "..ap);
end

function wowkemonUpdateOpponentHP(newHP,maxHP)
    wowkemonPvpFrame.OpponentHP:SetText(newHP.."/"..maxHP);
end

function wowkemonUpdateFeedbackText(msg,noloop)
  wowkemonPvpFrame.FeedbackString:SetText(msg);
  if noloop == nil or false then
      Wowkemon__wait(2,wowkemonUpdateFeedbackText,"",true);
    end
end


function createPlayerAnimGroups()
  local playerAnimGroup = wowkemonPvpFrame.player:CreateAnimationGroup("WowkemonPlayersAvatarAnimGrp",wowkemonPvpFrame);
  local transLeft = playerAnimGroup:CreateAnimation("Translation");
  transLeft:SetOffset(-10,0);
  transLeft:SetOrder(1);
  local transRight = playerAnimGroup:CreateAnimation("Translation");
  transRight:SetOffset(10,0);
  transRight:SetOrder(2);
  playerAnimGroup:SetLooping("BOUNCE");
  playerAnimGroup:Play();
  Wowkemon__wait(1,endAnimLoop,playerAnimGroup)
end

function createOpponentAnimGroups()
  local opponentAnimGroup = wowkemonPvpFrame.Opponent:CreateAnimationGroup("WowkemonPlayersAvatarAnimGrp",wowkemonPvpFrame);
  local transLeft = opponentAnimGroup:CreateAnimation("Translation");
  transLeft:SetOffset(-10,0);
  transLeft:SetOrder(1);
  local transRight = opponentAnimGroup:CreateAnimation("Translation");
  transRight:SetOffset(10,0);
  transRight:SetOrder(2);
  opponentAnimGroup:SetLooping("BOUNCE");
  opponentAnimGroup:Play();
  Wowkemon__wait(1,endAnimLoop,opponentAnimGroup);
end

function endAnimLoop(ref)
  ref:Stop()
end
